﻿using WpfConsole;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

using System.Linq;
using System.Collections.Generic;
using IdeaBlade.Core;
using IdeaBlade.EntityModel;
using IdeaBlade.Linq;
using IdeaBlade.Validation;
using DomainModel;

namespace Test
{
    
    
    /// <summary>
    ///This is a test class for MainDemoTest and is intended
    ///to contain all MainDemoTest Unit Tests
    ///</summary>
  [TestClass()]
  public class MainDemoTest {


    private TestContext testContextInstance;

    /// <summary>
    ///Gets or sets the test context which provides
    ///information about and functionality for the current test run.
    ///</summary>
    public TestContext TestContext {
      get {
        return testContextInstance;
      }
      set {
        testContextInstance = value;
      }
    }

    #region Additional test attributes
    // 
    //You can use the following additional attributes as you write your tests:
    //
    //Use ClassInitialize to run code before running the first test in the class
    //[ClassInitialize()]
    //public static void MyClassInitialize(TestContext testContext)
    //{
    //}
    //
    //Use ClassCleanup to run code after all tests in a class have run
    //[ClassCleanup()]
    //public static void MyClassCleanup()
    //{
    //}
    //
    //Use TestInitialize to run code before running each test
    //[TestInitialize()]
    //public void MyTestInitialize()
    //{
    //}
    //
    //Use TestCleanup to run code after each test has run
    //[TestCleanup()]
    //public void MyTestCleanup()
    //{
    //}
    //
    #endregion


    /// <summary>
    ///A test for BasicQuerySyntaxQuery
    ///</summary>
    [TestMethod()]
    public void BasicQuerySyntaxQueryTest() {
      ResultsReporter callbackMethod = null; // TODO: Initialize to an appropriate value
      MainDemo target = new MainDemo(callbackMethod); // TODO: Initialize to an appropriate value
      target.BasicQuerySyntaxQuery();
      Assert.Inconclusive("A method that does not return a value cannot be verified.");
    }


    /// <summary>
    /// Verifies that an active EntityListManager responds to the clearing of retrieval of
    /// data from a database by updating its managed list; 
    ///</summary>
    [TestMethod()]
    public void TestEntityListManagerAfterCacheClear() {
      NorthwindIBEntities mgr = new NorthwindIBEntities();

      var filter = new Predicate<Customer>(
          delegate(Customer aCustomer) { return aCustomer.Country == "France"; });
      //EntityListManager<Customer> customersListManager = new EntityListManager<Customer>(
      //  mgr, filter, new EntityProperty[] { Customer.CountryEntityProperty });

      EntityListManager<Customer> customersListManager = new EntityListManager<Customer>(
        mgr, filter, new EntityProperty[] { Customer.PropertyMetadata.Country });

      List<Customer> frenchCustomers = new List<Customer>();
      bool refreshListWhenPlacedUnderManagement = true;
      customersListManager.ManageList(frenchCustomers, refreshListWhenPlacedUnderManagement);

      mgr.Customers.ToList();
      int customersInListBeforeClearingCache = frenchCustomers.Count;
      mgr.Clear();
      Assert.IsTrue(customersInListBeforeClearingCache > 0 && frenchCustomers.Count == 0,
        "List 'frenchCustomers' should be empty after clearing cache");
    }

    /// <summary>
    /// 
    ///</summary>
    [TestMethod()]
    public void TestEntityListManagerAfterRestoreCacheState() {
      NorthwindIBEntities mgr = new NorthwindIBEntities();

      var filter = new Predicate<Customer>(
          delegate(Customer aCustomer) { return aCustomer.Country == "France"; });
      EntityListManager<Customer> customersListManager = new EntityListManager<Customer>(
        mgr, filter, new EntityProperty[] { Customer.PropertyMetadata.Country });

      List<Customer> frenchCustomers = new List<Customer>();

      mgr.Customers.ToList();
      string cacheStateFilePath = "cacheState.bin";
      mgr.CacheStateManager.SaveCacheState(cacheStateFilePath);
      mgr.Clear();

      // Put list under the control of the ListManager...
      bool refreshListWhenPlacedUnderManagement = true;
      customersListManager.ManageList(frenchCustomers, refreshListWhenPlacedUnderManagement);

      mgr.CacheStateManager.RestoreCacheState(cacheStateFilePath);
      Assert.IsTrue(frenchCustomers.Count > 0, "List 'frenchCustomers' should not be empty after restoring customers from CacheState file");
    }


  }
}
