﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Linq.Expressions;
using System.Collections;
using System.Reflection;

using IdeaBlade.EntityModel;
using IdeaBlade.Linq;
using DomainModel;

namespace WpfConsole {

  public class MainDemo {
    ResultsReporter _resultsReporter;

    public MainDemo(ResultsReporter callbackMethod) {
      Utility.InitializeDemo(_nameDemo, ref callbackMethod, ref _resultsReporter, ref _localOutput);
    }

    public void BasicQuerySyntaxQuery() {
      _localOutput.Append(String.Format("[{0}] Started...\n", _nameBasicQuerySyntaxQuery));

      Utility.ResetEntityManager(_em1);
      var customersQuery =
        from cust in _em1.Customers
        where cust.ContactTitle == "Sales Representative"
        orderby cust.CompanyName
        select cust;

      _localOutput.Append(string.Format("[{0}] Retrieved {1} customers\n", 
        _nameBasicQuerySyntaxQuery, customersQuery.ToList().Count));
      Utility.FlushOutputBuffer(_localOutput, _resultsReporter);
    }

    #region Private Fields

    const string _nameDemo = "MainDemo (MDM)";
    const string _nameBasicQuerySyntaxQuery = "MDM:BasicQuerySyntaxQuery";
    const string _nameTestContainsQuery = "MDM:TestContainsQuery";

    NorthwindIBEntities _em1 = new NorthwindIBEntities();
    StringBuilder _localOutput;

    #endregion Private Fields

  }
}
