﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports System.Linq.Expressions
Imports System.Collections
Imports System.Reflection

Imports IdeaBlade.EntityModel
Imports IdeaBlade.Linq
Imports DomainModel


Public Class MainDemo
    Private _resultsReporter As ResultsReporter

    Public Sub New(ByVal callbackMethod As ResultsReporter)
        Utility.InitializeDemo(_nameDemo, callbackMethod, _resultsReporter, _localOutput)
        AddHandler _em1.EntityServerError, Sub(o As Object, e As EntityServerErrorEventArgs)
                                               MessageBox.Show(e.Exception.Message)
                                           End Sub
    End Sub

    Public Sub BasicQuerySyntaxQuery()
        _localOutput.Append([String].Format("[{0}] Started..." & vbLf, _nameBasicQuerySyntaxQuery))

        Utility.ResetEntityManager(_em1)
        Dim customersQuery = From cust In _em1.Customers _
         Where cust.ContactTitle = "Sales Representative" _
         Order By cust.CompanyName _
         Select cust

        _localOutput.Append(String.Format("[{0}] Retrieved {1} customers" & vbLf, _nameBasicQuerySyntaxQuery, customersQuery.ToList().Count))
        Utility.FlushOutputBuffer(_localOutput, _resultsReporter)
    End Sub

#Region "Private Fields"

    Const _nameDemo As String = "MainDemo (MDM)"
    Const _nameBasicQuerySyntaxQuery As String = "MDM:BasicQuerySyntaxQuery"
    Const _nameTestContainsQuery As String = "MDM:TestContainsQuery"

    Private _em1 As New NorthwindIBEntities()
    Private _localOutput As StringBuilder

#End Region

End Class