﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Imports IdeaBlade.EntityModel
Imports DomainModel


Public Delegate Sub ResultsReporter(ByVal output As String)

Public NotInheritable Class Utility
    Private Sub New()
    End Sub

    Public Shared Sub ResetEntityManager(ByVal em As EntityManager)
        em.Clear()
  End Sub

    Public Shared Function DisplayCacheContents(ByVal em As NorthwindIBEntities, ByVal headerMessage As String) As String
        Dim output As New StringBuilder(headerMessage & vbLf)
        output.Append([String].Format(vbTab & "Customers: {0}", em.Customers.With(QueryStrategy.CacheOnly).Count()) & vbLf)
        output.Append([String].Format(vbTab & "Orders: {0}", em.Orders.With(QueryStrategy.CacheOnly).Count()) & vbLf)
        output.Append([String].Format(vbTab & "OrderDetails: {0}", em.OrderDetails.With(QueryStrategy.CacheOnly).Count() + vbLf))
        output.Append([String].Format(vbTab & "Products: {0}", em.Products.With(QueryStrategy.CacheOnly).Count() + vbLf))
        output.Append([String].Format(vbTab & "Suppliers: {0}", em.Suppliers.With(QueryStrategy.CacheOnly).Count() + vbLf))
        output.Append([String].Format(vbTab & "Employees: {0}", em.Employees.With(QueryStrategy.CacheOnly).Count() + vbLf))
        output.Append([String].Format(vbTab & "EmployeeTerritories: {0}", em.EmployeeTerritories.With(QueryStrategy.CacheOnly).Count() + vbLf))
        Return output.ToString()
    End Function

    Public Shared Function DisplayCacheContents(ByVal em As NorthwindIBEntities) As String
        Return DisplayCacheContents(em, "Contents of Cache:")
    End Function

    Public Shared Function GetMethodOutputHeader(ByVal methodName As String) As String
        Dim underline As String = New [String]("="c, methodName.Length + 2)
        Return [String].Format("{0}" & vbLf & "{1}()" & vbLf & "{2}" & vbLf, underline, methodName, underline)
    End Function

    Public Shared ReadOnly Property NoOutputMessage() As String
        Get
            Return "This method produces no signficant output: simply inspect the source code for syntax models."
        End Get
    End Property

    Public Shared Sub FlushOutputBuffer(ByVal localOutput As StringBuilder, ByVal reporter As ResultsReporter)
        Dim output As String = localOutput.ToString()
        localOutput.Clear()

        ' It's crucial to clear the localOutput buffer before calling the reporter callback method.
        ' The latter gives the order to execute the next sample in the sequence, and that
        ' sample immediately begins adding output to the same buffer.
        reporter(output)
    End Sub

    Public Shared Sub InitializeDemo(ByVal nameOfDemo As String, ByRef callbackMethod As ResultsReporter, ByRef localCallbackDelegateInstance As ResultsReporter, ByRef localOutputStringBuilder As StringBuilder)
        localCallbackDelegateInstance = callbackMethod
        localOutputStringBuilder = New StringBuilder()
        localOutputStringBuilder.Append([String].Format(vbLf & ">>> Initializing [{0}]..." & vbLf, nameOfDemo))
    End Sub

End Class